#include "TH2.h"
#include "ScanRoot.h"
#include "TCutG.h"
#include "TFile.h"

TH1F* h1[100];
TH2F* h2[100];
TCutG* banana[100];

/////////////////////////////////////////////////////////////////////
void fillHistograms(short npar, float *par)
{
  if(npar>0)
  {
    if(par[1]>0)               h1[0]->Fill(par[1]);
    if(par[2]>0)               h1[1]->Fill(par[2]);    
    if(par[1]>0 && par[2]>0)   h2[0]->Fill(par[1],par[2]); 
    
    // test is the pair (X,Y)=(par[1],par[2]) is inside the 
    // graphical cut   
    if(banana[0]->IsInside(par[1],par[2])) h2[1]->Fill(par[1],par[2]);
  }
}
/////////////////////////////////////////////////////////////////////
void bookHistograms(ScanRoot* spm)
{  
  // opening banana file for input
  TFile *f=new TFile("banana.root");
  // getting pointers to bananas
  banana[0] = (TCutG*)f->Get("banana0;1");
  // remember not to close the file.
  // if you close the file the banana will not be
  // available anymore
  
  // this next line is to be sure that the histograms are
  // saved in the correct ROOT directory
  spm->cd();
  
  // booking histograms...
  h1[0] = new TH1F("h1","h1",1024,0,4096);
  h1[1] = new TH1F("h2","h1",1024,0,4096);
  
  h2[0] = new TH2F("D2","D2",512,0,4096,512,0,4096);
  h2[1] = new TH2F("D2-banana","D2-banana",512,0,4096,512,0,4096);
  
  // this line links the histogram filling function
  // to the acquisition program.
  spm->fillHistograms = &fillHistograms;
    
  return;
}
/////////////////////////////////////////////////////////////////////
void init()
{
}
/////////////////////////////////////////////////////////////////////
void finish()
{
}
